
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>iCheck的全选和获取value / 憋错料</title>

    <meta name="description" content="iCheck的全选和获取value 在使用jQuery iCheck 插件的时候遇到了一个问题,就是当我们使用普通的js全选功能无效了. $(&quot;#checkall&quot;).click( function(){ if(this.checked){ $(&quot;input[name='checkname']&quot;).each(function(){this.checked=true;}); }else{ $(&quot;input[name='checkname']&quot;).each(function( ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">iCheck的全选和获取value</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>在使用jQuery iCheck 插件的时候遇到了一个问题，就是当我们使用普通的js全选功能无效了。</p>
<pre>$("#checkall").click(
        function(){
            if(this.checked){
                $("input[name=‘checkname‘]").each(function(){this.checked=true;});
            }else{
                $("input[name=‘checkname‘]").each(function(){this.checked=false;});
            }
        }
    );</pre>
<p>这样来写对默认的checkbox框没问题，但是当使用iCheck 插件后将无效。</p>
<p>那么该怎么解决呢？</p>
<p>最后是在stackoverflow 找到的解决方法：</p>
<p>地址是这里：&nbsp;<a href="http://stackoverflow.com/questions/17820080/function-select-all-and-icheck" rel="external nofollow noreferrer">http://stackoverflow.com/questions/17820080/function-select-all-and-icheck</a></p>
<pre>//全选获取数值
    var checkAll = $(‘input.all‘);
    var checkboxes = $(‘input.check‘);
    checkAll.on(‘ifChecked ifUnchecked‘, function(event) {
        if (event.type == ‘ifChecked‘) {
            checkboxes.iCheck(‘check‘);
        } else {
            checkboxes.iCheck(‘uncheck‘);
        }
    });
    checkboxes.on(‘ifChanged‘, function(event){
        if(checkboxes.filter(‘:checked‘).length == checkboxes.length) {
            checkAll.prop(‘checked‘, ‘checked‘);
        } else {
            checkAll.removeProp(‘checked‘);
        }
        checkAll.iCheck(‘update‘);
    });</pre>
<p>在解决了全选问题后，又遇到了一个新的问题，获取选中的checkbox的value的时候，使用：$(this).attr(‘checked‘);获取不到值了~，蛋疼。</p>
<p>最后几经Google搜索，还是在stackoverflow 找到了启发，判断checkbox的布尔值，使用 ：$(this).is(‘:checked‘);</p>
<p>最后代码的解决方法如下：</p>
<pre>$(".ajax-delete").click(function(){
    var url = $(this).attr(‘data-url‘);
    var str="";
    var ids="";
    $("input[name=‘id‘]:checkbox").each(function(){
        if(true == $(this).is(‘:checked‘)){
            str+=$(this).val()+",";
        }
    });
    if(str.substr(str.length-1)== ‘,‘){
        ids = str.substr(0,str.length-1);
    }
    console.log(ids);
});</pre>
<p>延伸：</p>
<p>1.判断已选中的个数/长度</p>
<pre>var len = $("input[name=‘id‘]:checkbox").length;</pre>
<p>来自：http://www.tuicool.com/articles/aANRBv</p>
<p>官网：http://www.bootcss.com/p/icheck/</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-08 03:52:58 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/log/" title="log">log</a>, <a href="https://www.biecuoliao.com/tag/tac/" title="tac">tac</a>, <a href="https://www.biecuoliao.com/tag/ajax/" title="ajax">ajax</a>, <a href="https://www.biecuoliao.com/tag/each/" title="each">each</a>, <a href="https://www.biecuoliao.com/tag/art/" title="art">art</a>, <a href="https://www.biecuoliao.com/tag/height/" title="height">height</a>, <a href="https://www.biecuoliao.com/tag/checkbox/" title="checkbox">checkbox</a>, <a href="https://www.biecuoliao.com/tag/%e6%8f%92%e4%bb%b6/" title="插件">插件</a>, <a href="https://www.biecuoliao.com/tag/%e5%85%a8%e9%80%89/" title="全选">全选</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>iCheck的全选和获取value的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RxYKv4.html" rel="bookmark">BootStrap iCheck插件全选与获取value值的解决方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这篇文章主要介绍了BootStrap iCheck插件全选与获取value值的解决方法,解决方法其实很简单,下面小编给大家分享下这方面的知识 在使用jQuery iCheck 插件的时候遇到了一个问题,就是当我们使用普通的js全选功能无效了. $(&quot;#checkall&quot;).click( function(){ if(this.checked){ $(&quot;input[name='checkname']&quot;).each(function(){this.checked=tru			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wrrD80.html" rel="bookmark">bootstrap iCheck插件 全选和获取value值的解决方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在使用jQuery iCheck 插件的时候遇到了一个问题,就是当我们使用普通的js全选功能无效了. $(&quot;#checkall&quot;).click(     function(){         if(this.checked){             $(&quot;input[name='checkname']&quot;).each(function(){this.checked=true;});         }else{             $(&quot;input[			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41eQNg4.html" rel="bookmark">JQuery 判断checkbox是否选中，checkbox全选，获取checkbox选中值</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot;http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd&quot;&gt; &lt;html xmlns=&quot;http://www.w3.org/1999/xhtml&quot;&gt; &lt;head&gt; &lt;meta http-equiv=&quot;Content-			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBm2nq4.html" rel="bookmark">jquery1&period;11 操作checkbox：全选、取消全选、获取选择元素、获取取消选择元素（总结）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				jquery1.11.1版本完成对checkbox的操作 1. 使用属性prop设置选中状态 2.使用:checked和:not(:checked)获取选中的元素 源码: &lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head&gt; &lt;meta charset=&quot;utf-8&quot;&gt; &lt;meta http-equiv=&quot;X-UA-Compatible&quot; content=&quot;IE=edge,chrome=1&quo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0ebZ6D3.html" rel="bookmark">Jquery 实现动态添加table tr 和删除tr 以及checkbox的全选 和 获取添加TR删除TR后的数据</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				关于jquery实现动态添加table tr的问题我也不多说了 上面代码很多地方都有注释的 关于返回的 编辑后的table 数据 我这里想说的是我直接把他保存成一个连接起来的字符串了 格式 str=XXX | XXX | XXX , XXX | XXX | XXX , XXX | XXX | XXX 你也可以保存成对象类型的  我是为了方便后台的操作才这样做的 话不多说直接代码: &lt;html&gt; &lt;head&gt; &lt;meta http-equiv=&quot;Content-Typ			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wmzVNM.html" rel="bookmark">分享知识-快乐自己：复选框、全选&sol;反选&sol;获取值</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1):复选框 全选与反选 .获取选中的值 取消选中的框 1.全选/反选 &lt;body&gt; &lt;input type=&quot;checkbox&quot; checked&gt; &lt;input type=&quot;checkbox&quot;&gt; &lt;input type=&quot;checkbox&quot;&gt; &lt;input type=&quot;checkbox&quot;&gt; &lt;input type=&quot;checkbox&quot;&gt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz1lk84.html" rel="bookmark">Android高级控件（一）&mdash;&mdash;ListView绑定CheckBox实现全选，添加和删除等功能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android高级控件(一)--ListView绑定CheckBox实现全选,添加和删除等功能 这个控件还是挺复杂的.也是项目中应该算是比較经常使用的了,所以写了一个小Demo来讲讲,主要是自己定义adapter的使用方法.加了非常多的推断等等等等-.我们先来看看实现的效果吧! 好的,我们新建一个项目LvCheckBox 我们事先先把这两个布局写好吧,一个是主布局,另一个listview的item.xml.相信不用多说 activity_main.xml &lt;LinearLayout xmlns:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kl8Rz3.html" rel="bookmark">关于checkbox全选与反选的问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在一组checkbox中常有这样的需求,选择全选按钮,所有的选项必须全选上,当再次点击时,则所有的按钮必须反选,当点击一组checkbox时,只有有一个不选上,则按钮不选中,当所有的按钮全部选上时,此时全选按钮就选上,具体代码的思路如下: 1:触发全选按钮获取全选按钮的checked布尔值,将全选按钮的全选布尔值传给其他子序列checkbox,从而控制所有的checkbox 2:触发所有子选项checkbox,循环选择所有子选项的checkox布尔状态,当所有的子选项checkbox只要一项不选			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41Ra5GM.html" rel="bookmark">python 自动化测试多选框全选</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				def click_checkbox(self): ''' 多选框全选操作 获取全部的多选框,一定要用elements, 然后遍历,循环点击 防止反选,is_selected判断是否选中 选中返回True,否则返回False :return: ''' self.driver.get(r'E:\测试2\资料\radio.html') checkbox = self.driver.find_elements_by_xpath('//input[@type=&quot;checkbox&quot;]') for			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXYDnz0.html" rel="bookmark" class="title">bzoj4171 or 省队集训day3 chess&colon; Rhl的游戏</a>
					<div>
						[题目描述] RHL最近迷上一个小游戏:Flip it.游戏的规则很简单,在一个N*M的格子上,有一些格子是黑色,有一些是白色.每选择一个格子按一次,格子以及周围边相邻的格子都会翻转颜色(边相邻指至少 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KamyK4.html" rel="bookmark" class="title">Linux 程序设计学习笔记----进程管理与程序开发（下）</a>
					<div>
						转载请注明出处:http://blog.csdn.net/suool/article/details/38419983,谢谢! 进程管理及其控制 创建进程 fork()函数 函数说明具体参见:http ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MywVrE3.html" rel="bookmark" class="title">uva 10413 - Crazy Savages&lpar;拓展欧几里得&rpar;</a>
					<div>
						题目链接:uva 10413 - Crazy Savages 题目大意:一座山有m个山洞,形成一个圈,现在有n个部落的人,每个部落一开始住在ci山洞,第2天会向后面移动pi个位置,一共会在这座山住li ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDZ9xo3.html" rel="bookmark" class="title">Python之路Day6</a>
					<div>
						Day6的主要内容是: configparser模块 shutil模块 subprocess模块 处理xml的模块 1.configparser模块 #! /usr/bin/env python #  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AdBkD3.html" rel="bookmark" class="title">C语言之运算符</a>
					<div>
						一 赋值运算符 1.赋值运算符 //最基本的赋值运算符 int number = 2; //符合运算符: += -= *= /= %= /* + 加法运算 - 减法运算 * 乘法运算 / 除法运算 % ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RYBq5M.html" rel="bookmark" class="title">ubuntu和win7双系统的安装</a>
					<div>
						周末有点闲,想起来折腾一下ubuntu系统,顺便为以后更好学习开源软件做个铺垫,下面大致讲一下在win7下安装ubuntu的过程. 1. 准备一个8G的U盘 2. 官网上下载ubuntu 14.04  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/418J5O3.html" rel="bookmark" class="title">程序员转销售</a>
					<div>
						今天来第二家公司做软件销售,之前的那家不做的主要原因是高速公路市场太窄,公司的领导也不是很有能力,和他们在一起感觉没有什么前途,不是因为我走了而去说坏话.先写到这里,未完待续程序员转销售,布布扣,bu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bgA7e3.html" rel="bookmark" class="title">第83讲：Scala中List的实现内幕源码揭秘</a>
					<div>
						今天我们来学习一下scala的List的方法的内部源码的一些知识. 首先,take方法.take方法就是取列表的从第一个元素开始的前N个元素.如list.take(3),就是取list的前3个元素,返 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXLNwVM.html" rel="bookmark" class="title">记一些常用到的python中的函数</a>
					<div>
						1. zip()函数 它的作用是从参数中按顺序一一抽出子参数组出一个新的tuple.  直接看例子: &gt;&gt;&gt; mean = np.array([2, 5, 4]) &gt;&gt;& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qE8rp3.html" rel="bookmark" class="title">SQLite源码目录结构剖析</a>
					<div>
						研究的源码:sqlite-src-3081101 art 保存SQLite的形象图标 autoconf 提供config的配置文件 contrib doc ext mptest src test to ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kpjXl3.html" rel="bookmark" class="title">android 取消标题 程序意外停解决方法</a>
					<div>
						之前一直使用requestWindowFeature(Window.FEATURE_NO_TITLE);取消标题,程序老是报 java.lang.RuntimeException: Unable to ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoagaD3.html" rel="bookmark" class="title">只需2分钟，简单构建velocity web项目</a>
					<div>
						Velocity是一个基于java的模板引擎(template engine).它允许任何人仅仅简单的使用模板语言(template language)来引用由java代码定义的对象 velocity ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGpZRb0.html" rel="bookmark" class="title">git archive命令详解</a>
					<div>
						git archive可以将加了tag的某个版本打包提取出来,例如: git archive -v --format=zip v0.1 &gt; v0.1.zip --format表示打包的格式,如z ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JvXBB4.html" rel="bookmark" class="title">Centos7单台服务器搭建FastDFS&plus;Nginx</a>
					<div>
						Fastdfs+Nginx配置操作 单台配置 安装包下载: wget https://github.com/happyfish100/libfastcommon/archive/V1.0.7.tar. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWjlXG4.html" rel="bookmark" class="title">DB2查看数据库中的锁信息</a>
					<div>
						利用&quot;db2 connect to &lt;db name&gt;&quot;连接到数据库后,执行相关指令 查询锁快照信息 db2 get snapshot for locks on &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41nkZvM.html" rel="bookmark" class="title">模板代码</a>
					<div>
						/* Minification failed. Returning unminified contents. (187,73): run-time error CSS1036: Expected ex ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d7B6eM.html" rel="bookmark" class="title">如何让超出范围的文本自动显示为省略号&lpar;CSS&rpar;</a>
					<div>
						溢出文本显示省略号的效果: white-space:nowrap;  强制文本在一行显示 overflow:hidden;   溢出内容为隐藏 text-overflow:ellipsis;  当对象 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Rxvpj4.html" rel="bookmark" class="title">MySQL主从复制----同步与异步的配置</a>
					<div>
						简单来讲MySQL的主从复制就是一个C/S架构的应用.master可以认为是我们通常意义上所认为的server,slave可以当作是一台client.slave上的I/O线程去请求master上数据, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6vXK5M.html" rel="bookmark" class="title">HDU  6044--Limited Permutation（搜索&plus;组合数&plus;逆元）</a>
					<div>
						题目链接 Problem Description As to a permutation p1,p2,?,pn from 1 to n, it is uncomplicated for each 1≤ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OdQBG4.html" rel="bookmark" class="title">zabbix监控memcache状态及其他服务进程</a>
					<div>
						一.在客户端 1.到/usr/loca/zabbix/conf/zabbix_agentd.conf里添加 UserParameter=memcached_stats[*],(echo stats;  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.020 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
